;***************************************
;[DEBC] - LOGIC NUM OF SECTOR
;[HL] - ADDR

READ	CALL	CALC









L000	LD	(EXIT+#01),SP
	LD	IX,CCGMR
	PUSH	DE
	XOR	A
;---------------------------------------
	EXX
	POP	DE
	LD	HL,(CCYLL)
	EX	DE,HL
	SRL	H
	RR	L
	EX	AF,AF'

	XOR	A
	LD	C,A
	LD	B,A
	SBC	HL,DE
	INC	BC
	JR	NC,$-#03
	ADD	HL,DE
	DEC	BC            ;[BC] = CYL

	LD	E,(IX+#01)
	XOR	A
	LD	D,A
	SBC	HL,DE
	INC	A
	JR	NC,$-#03
	ADD	HL,DE
	DEC	A

;[A] - HEAD; [L] - SEC; [BC] - CYLL

	LD	D,A
	LD	E,L
;[HL] - CYLL; [D] - DRV & HEAD; [E] - SEC

	LD	BC,#1FFD
	LD	A,#04
	DI
	OUT	(C),A
	LD	BC,#FEBE
	OUT	(C),D         ;DRV & HEAD
	DEC	B
	OUT	(C),H         ;CYLL HIGH
	DEC	B
	OUT	(C),L         ;CYLL LOW
	DEC	B
	OUT	(C),E         ;SEC
	EXX
	EX	AF,AF'

	LD	B,#FA
	OUT	(C),D
	CALL	COM

;***************************************
WAIT	LD	B,#FF
	IN	A,(C)
	ADD	A,A
	JR	C,$-#03
	BIT	4,A
	RET	NZ
	BIT	1,A
	RET	Z
	LD	A,#07
	JR	COM2+#02

;***************************************
COM	OR	A
	LD	B,#FF
	IN	A,(C)
	BIT	6,A
	JR	Z,$-#04

	LD	A,#20
	JR	NC,$+#04
	OR	#10
	OUT	(C),A

COM1	IN	A,(C)
	ADD	A,A
	JR	C,$-#03
	BIT	1,A
	JR	NZ,COM2
	BIT	4,A
	JR	Z,COM1
	RET

COM2	LD	A,#0A
	SCF
	JP	EXIT
;***************************************
;reading bytes with speed 20.4375 tact's per byte
RDHALF	LD	A,#08
	PUSH	DE
	LD	DE,#D8F8
RDHLF0	DEFB	#43,#ED,#A2,#42,#ED,#A2     ;LD B,E:INI:LD B,D:INI
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEFB	#43,#ED,#A2,#42,#ED,#A2
	DEC	A
	JP	NZ,RDHLF0
	POP	DE
	RET



;***************************************
;[HL] - SEC, HEA, SEC*HEA
;[C] - 2-MASTER, 1-SLAVE
;
INIPR	LD	A,#02
	OUT	(#FE),A
	RET
	LD	E,C
	CALL	DOS_ON
	LD	A,(HL)
	LD	BC,#FABE
	OUT	(C),A
	INC	HL
	LD	A,(HL)
	DEC	A
	OR	#A0
	BIT	0,E
	JR	NZ,$+#04
	OR	#10
	LD	B,#FE
	OUT	(C),A
	LD	B,#FF
	LD	A,#91
	OUT	(C),A
	CALL	WAIT
	JP	DOSOFF

;***************************************
HDDIA	CALL	DIAG
	CP	#01
	RET	Z
	LD	(HDDG),A
	BIT	7,A
	JR	Z,HDDIA0
	PUSH	AF
	LD	HL,HDDIA1
	CALL	ERRP
	POP	AF
HDDIA0	AND	#7F
	DEC	A
	RET	Z
	LD	HL,HDDIA1+#0B
	INC	(HL)
	LD	HL,HDDIA1
	JP	ERRP

;***************************************
HDSEA	LD	A,#A0
	CALL	SETDR
	OR	A
	JR	NZ,HDSEA0
	LD	HL,HDSEA1
	CALL	ERRP
	LD	HL,HDPRS
	RES	0,(HL)
HDSEA0	LD	A,#B0
	CALL	SETDR
	OR	A
	RET	NZ
	LD	HL,HDPRS
	RES	1,(HL)
	LD	HL,HDSEA1+#0B
	INC	(HL)
	LD	HL,HDSEA1
	JP	ERRP

;---------------------------------------
HDDIA1	DEFM	"⥫ 0 ࠢ!"
	DEFB	#00
HDSEA1	DEFM	"⥫ 0 !"
	DEFB	#00

;***************************************
DIAG	CALL	DOS_ON
	LD	BC,#FFBE
	LD	A,#90
	OUT	(C),A
	CALL	WAIT
	LD	BC,#F9BE
	IN	A,(C)
	JR	DOSOFF

;***************************************
SETDR	CALL	DOS_ON
	LD	BC,#FEBE
	OUT	(C),A
	CALL	WAIT
	JR	DOSOFF

;***************************************
DOS_ON	DI
	PUSH	BC
	PUSH	AF
	LD	BC,#1FFD
	LD	A,#04
	OUT	(C),A
	POP	AF
	POP	BC
	RET
;---------------------------------------
DOSOFF	PUSH	BC
	PUSH	AF
	LD	BC,#1FFD
	XOR	A
	OUT	(C),A
	POP	AF
	POP	BC
	EI
	RET
;---------------------------------------
;WAIT     LD     BC,#FFBE
	IN	A,(C)
	BIT	7,A
	JR	NZ,$-#04
	RET
